CON

'{ Hybrid Block
  _clkmode = xtal1 + pll16x
  _xinfreq = 6_000_000
  tvpins = %011_0000
'}

{ Proto/Demo Block
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  tvpins = %001_0101
'}

x_tiles = 40
y_tiles = 24

OBJ
  tv    : "Apple][TV"

VAR
  byte  Screen[1024]
  long  txtx
  long  txty
  long  txtcol

  long          params[4]            'parameter block for the TV driver                       
                '[0] screen memory                           
                '[1] font table
                '[2] pix_mode not yet implemented...
                '[3] colors, or 16 bit mode = $00

PUB start | i,x,y
  bytefill(@Screen,"A",x_tiles*y_tiles)
  i:=0
  repeat y from 0 to 23
    repeat x from 0 to 39
      Screen[((y&7)*128)+((y/8)*40)+x]:=i'//96+32 '(i//10)+"0"
      i++


  params[0] := @Screen                               'HUB Address of Text Display Buffer
  params[1] := @font                                 'HUB Address of font table used by TV display  (ASCII)
  params[2] := 1                                     '0=TextMode,1=Mix,2=Fat Pixels  
  params[3] := $0000702                              'Text display colors (Black and White default)
  tv.start(@params)                                  'start the tv cog & pass it the parameter block
    
  printat(string("System Boot."),0,0,$46)

PUB printat(p,x,y,clr)
  txtx:=x
  txty:=y
  txtcol:=clr
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++    

PUB print(p)
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++
  txtx:=0
  if txty<23
    txty++    

PUB print_char(p) | y, s,d
  Screen[txty<<5+txtx]:=p
  txtx++
  if txtx>31
    txtx:=0
    if txty<23
      txty++


DAT

font          file      "text8x8x96.JB2"